$('#tutorial').on('click', function () {
    $(document).ready(async function () {
        const driver = new Driver({
            doneBtnText: 'Sair',
            closeBtnText: 'Fechar',
            nextBtnText: 'Próximo',
            prevBtnText: 'Anterior',
            allowClose: false
        });
        driver.defineSteps([{
            element: '#btnFiltros',
            popover: {
                title: 'Botão Filtros',
                description: 'Clique aqui para filtrar a consulta.',
                position: 'right'
            }
        },
        {
            element: '#btnNovaRegiao',
            popover: {
                title: 'Botão Incluir',
                description: 'Clique aqui para iniciar o cadastro de uma tabela de preço.',
                position: 'right'
            }
        },
        {
            element: '#tabelaRegiao',
            popover: {
                title: 'Tabela de preço',
                description: 'Aqui estão os dados das tabelas de preço cadastradas.',
                position: 'top'
            }
        }
        ]);
        driver.start();
    });
});
$(document).ready(async function () {
    const permissaoUsuarioLogado = await permissaoAcessos("REGIAO");

    // autocompleta
    $('#txtRegiaoConsulta').autocompleta(1, `JSON={ "tabela":"Regiao", "camposSelect":[ "regiao chave", "descricao descricao"], "where": null}`);
    // pesquisa
    $('#btn-Regiao').pesquisa('#txtRegiaoConsulta', 'REGIAO', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"regiao", "camposSelect":[ "regiao", "descricao"]}`, 'Pesquisa Tabela de Preço', 'regiao');
    // limpacampo
    $('#btn-limpa-Regiao').on('click', function () {
        $('#txtRegiaoConsulta').val('');
    });

    $('#btnFiltros').on('click', function () {
        $('#modal-filtros').modal('show');
    });

    $('#btnNovaRegiao').on('click', function () {
        if (permissaoUsuarioLogado.INCLUI == 'S') {
            window.location.href = "tabeladepreco/create";
        } else {
            msgAlertaSemConfirmacao("Sem permissão para incluir!");
        }
    });

    function retornaBotaoOpcoes(data) {
        var retorno = '<div style="text-align:start;"> ' +
          '    <button class="btn btn-info btn-sm dropdown-toggle btnVerificaOpcoes" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"> ' +
          '      ' + data + ' ' +
          '    </button> ' +
          '    <div class="dropdown-menu"> ' +
          '    <button class="dropdown-item" type="button" title="Editar" id="btn-editar">Editar</button>    ' +
          '    <button class="dropdown-item" type="button" title="Excluir" id="btn-excluir">Excluir</button>  ' +
          '</div>';
        return retorno;
      };

    consultaRegiao();

    $('#btnConsultar').on('click', async function () {
        $('#modal-filtros').modal('hide');
        await consultaRegiao(true);
    });

    $('#btnLimparFiltros').on('click', async function () {
        $('#txtRegiaoConsulta').val('');
    });

    async function consultaRegiao(bBotao = false) {
        try {
            $.LoadingOverlay("show");
            let response;
            let regiao = pegaChave('#txtRegiaoConsulta') != '' ? ` AND REGIAO = '${pegaChave('#txtRegiaoConsulta')}'` : '';
            if (bBotao) {
                response = await requisicao('GET', '/Sisplan/Funcoes/V1/pesquisa?', `JSON={ "tabela":"regiao", "camposSelect":[ "REGIAO", "DESCRICAO"], "where": ["1=1 ${regiao}"]}`, null);
            } else {
                response = await requisicao('GET', '/Sisplan/Funcoes/V1/pesquisa?', 'JSON={ "tabela":"regiao", "camposSelect":[ "REGIAO", "DESCRICAO"], "where": null, "limit": 10000}', null);
            }

            if (!response) {
                $.LoadingOverlay("hide");
                return;
            }

            let jsonStr = await response.json();
            if (response.status != 200) {
                $.LoadingOverlay("hide");
                msgErro(jsonStr.RESULT[0].mensagem);
                return;
            }

            $('#tabelaRegiao').DataTable({
                destroy: true,
                lengthChange: false,
                serverside: true,

                "autoWidth": true,
                "data": jsonStr.RESULT[0],
                "columns": [{
                    "data": "REGIAO"
                },
                {
                    "data": "DESCRICAO"
                },
                ],
                "columnDefs": [{
                    targets: [0], render: function (data, type, row) {
                        return retornaBotaoOpcoes(data);
                      }
                }]
            });

            $.LoadingOverlay("hide");
        } catch (error) {
            console.error(error);
        }

    }

    $('#tabelaRegiao').on('click', '#btn-editar', async function () {
        if (permissaoUsuarioLogado.ALTERA == 'S') {
            let data = $('#tabelaRegiao').DataTable().row($(this).parents('tr')).data();
            let registroLiberado = await verificarRegistro('REGIAO', data.REGIAO);
            if (registroLiberado) {
                window.location.href = `tabeladepreco/${data.REGIAO}`;
            }
        } else {
            msgAlertaSemConfirmacao("Sem permissão para alterar!");
        }
    });

    $('#tabelaRegiao').on('dblclick', 'tr', async function () {
        if (permissaoUsuarioLogado.ALTERA == 'S') {
            let data = $('#tabelaRegiao').DataTable().row($(this)).data();
            let registroLiberado = await verificarRegistro('REGIAO', data.REGIAO);
            if (registroLiberado) {
                window.location.href = `tabeladepreco/${data.REGIAO}`;
            }
        } else {
            msgAlertaSemConfirmacao("Sem permissão para alterar!");
        }
    });

    $('#tabelaRegiao').on('click', '#btn-excluir', async function () {
        if (permissaoUsuarioLogado.EXCLUI == 'S') {
            msgAlerta('Você realmente deseja excluir esse registro?', async () => {
                const data = $("#tabelaRegiao").DataTable().row($(this).parents("tr"));
                await excluiRegistro(data);
            });
        } else {
            msgAlertaSemConfirmacao("Sem permissão para excluir!");
        }

        
    });

    async function excluiRegistro(data) {
        try {
            $.LoadingOverlay("show");
            try {
                let valorLinha = data.data();
                const tabela = 'REGIAO'
                let response = await requisicao("DELETE", "/Sisplan/Cadastros/v1/regiao?", `CODIGOREGIAO=${(valorLinha.REGIAO)}&VALOR=${(valorLinha.REGIAO)}&TABELA=${tabela}`, null);
                if (!response) {
                    return;
                }
                if (response.status != 200) {
                    let jsonStr = await response.json();
                    msgErro(jsonStr.mensagem);
                    return;
                }

                toastr.success("Exclusão efetuada com sucesso!", "Confirmação", {
                    toastClass: "success",
                    iconClasses: {
                        error: "alert-error",
                        info: "alert-info",
                        success: "alert-success",
                        warning: "alert-warning",
                    },
                    positionClass: "toast-top-center",
                    progressBar: true,
                    timeOut: 3000,
                    fadeOut: 1000,
                    onHidden() {
                        data.remove().draw(false);
                    },
                }).css({
                    "margin-top": "20%",
                    width: "500px",
                    "max-width": "500px",
                });

            } catch (error) {
                console.error(error);
            }
        } finally {
            $.LoadingOverlay("hide");
        }
    }
});